package com.zenika.presentation.annotations.compilation;

import java.util.Set;
import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.Filer;
import javax.annotation.processing.Messager;
import javax.annotation.processing.RoundEnvironment;
import javax.annotation.processing.SupportedAnnotationTypes;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.lang.model.util.Elements;
import javax.lang.model.util.Types;
import javax.tools.Diagnostic;

@SupportedAnnotationTypes("com.zenika.presentation.annotations.compilation.*")
@SupportedSourceVersion(SourceVersion.RELEASE_6)
public class ListingProcessor extends AbstractProcessor {

    @Override
    public boolean process(Set<? extends TypeElement> annotations, RoundEnvironment roundEnv) {

        Types types         = processingEnv.getTypeUtils();
        Elements elements   = processingEnv.getElementUtils();
        Messager messager   = processingEnv.getMessager();
        Filer filer         = processingEnv.getFiler();
 
        for (TypeElement annotation : annotations) {
            for (Element e : roundEnv.getElementsAnnotatedWith(annotation)) {
                messager.printMessage(Diagnostic.Kind.NOTE, e.getSimpleName());
            }
        }

        return false; 
    }
    
}