package com.zenika.presentation.annotations.compilation;

import java.util.List;
import java.util.Set;
import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.Filer;
import javax.annotation.processing.Messager;
import javax.annotation.processing.RoundEnvironment;
import javax.annotation.processing.SupportedAnnotationTypes;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.Element;
import javax.lang.model.element.ExecutableElement;
import javax.lang.model.element.TypeElement;
import javax.lang.model.util.ElementFilter;
import javax.lang.model.util.Elements;
import javax.lang.model.util.Types;
import javax.tools.Diagnostic;

@SupportedAnnotationTypes("com.zenika.presentation.annotations.compilation.MessageHolder")
@SupportedSourceVersion(SourceVersion.RELEASE_6)
public class MessageHolderProcessor extends AbstractProcessor {

    @Override
    public boolean process(Set<? extends TypeElement> annotations, RoundEnvironment roundEnv) {

        Types types = processingEnv.getTypeUtils();
        Elements elements = processingEnv.getElementUtils();
        Messager messager = processingEnv.getMessager();
        Filer filer = processingEnv.getFiler();

        for (TypeElement annotation : annotations) {
            for (Element e : roundEnv.getElementsAnnotatedWith(annotation)) {

                boolean hasGetMessageMethod = false;
                List<ExecutableElement> methodElements = ElementFilter.methodsIn(e.getEnclosedElements());
                for (ExecutableElement methodElement : methodElements) {
                    if (methodElement.getSimpleName().contentEquals("getMessage")) {
                        hasGetMessageMethod = true;
                        break;
                    }
                }

                if(! hasGetMessageMethod) {
                    messager.printMessage(Diagnostic.Kind.ERROR,
                            "Classes annotated with MessageHolder must implement a getMessage() method.");
                }
            }
        }

        return false;
    }

}