package com.zenika.presentation.annotations.injection;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

import org.junit.BeforeClass;

import static org.junit.Assert.*;

public class Test {

    private static MyAnnotation myAnnotation;

    @BeforeClass
    public static void init() {

        myAnnotation = new MyAnnotation() {
            @Override
            public String message() {
                return MyAnnotation.defaultMessage;
            }
            @Override
            public int answer() {
                return MyAnnotation.defaultAnswer;
            }
            @Override
            public Class<? extends Annotation> annotationType() {
                return MyAnnotation.class;
            }
        };
        Class<? extends Annotation> annotClass = myAnnotation.annotationType();
    }

    //@org.junit.Test
    public void testClassInjection() {

        // Injection dans la classe Pojo
        AnnotationInjector.injectClass(Pojo.class, myAnnotation);

        // Test
        MyAnnotation a = Pojo.class.getAnnotation(MyAnnotation.class);
        if (a != null) {
            System.out.println("Annotation value is : " + a.message());
        } else {
            System.out.println("Failed !");
        }

    }


   @org.junit.Test
    public void testFieldInjection() throws Exception {

        Field f1 = Pojo.class.getDeclaredField("foo");
        AnnotationInjector.injectField(f1, myAnnotation);
        assertTrue(f1.isAnnotationPresent(MyAnnotation.class));
 
        Field f2 = Pojo.class.getDeclaredField("foo");
        System.out.println("f1 == f2 ? " + (f1==f2));
        assertFalse(f2.isAnnotationPresent(MyAnnotation.class));

    }



}
